// cnvfname.h

#ifndef CNVFNAME_H
#define CNVFNAME_H

#ifdef __cplusplus
extern "C" {
#endif


size_t ConvertFileNameA ( const char *szSrcFileName, char *szDstFileName, size_t nMaxLen, int IsConvertToShortName ) ;
size_t ConvertFileNameW ( const wchar_t *szSrcFileName, wchar_t *szDstFileName, size_t nMaxLen, int IsConvertToShortName ) ;


#ifdef UNICODE
#define ConvertFileName ConvertFileNameW
#else
#define ConvertFileName ConvertFileNameA
#endif


#ifdef __cplusplus
}
#endif

#endif


