// shfileop.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "shfileop.h"


// MAX_PATH 𒴂pX
#define MAX_LONG_PATH   0x7FFF   // max len of "\\?\C:\<path>", "\\?\UNC\<server>\<share>"



/////////////////////////////
//         ANSI          //
/////////////////////////////



// VF𗘗pĕ̃t@C폜 (ANSI)
// 폜ꂽt@C͂ݔֈړ
// Ŏw肳镶ɂ́AɌ'\0'
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As΂ȊOԂ
int ShellDeleteMultipleFilesA ( HWND hWnd, const char *szFileNameBuffer, int IsNoRecycleBin ) {

   if ( ! szFileNameBuffer ) return 1 ;

   SHFILEOPSTRUCTA ShFileOp = { 0 } ;
   ShFileOp.hwnd = hWnd ;
   ShFileOp.wFunc = FO_DELETE ;
   ShFileOp.pFrom = szFileNameBuffer ;
   ShFileOp.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI | ( hWnd ? 0 : FOF_SILENT ) | ( IsNoRecycleBin ? 0 : FOF_ALLOWUNDO ) ;

   return SHFileOperationA ( & ShFileOp ) || ShFileOp.fAnyOperationsAborted ;
}



// VF𗘗pĂP̃t@C폜 (ANSI)
// 폜ꂽt@C͂ݔֈړ
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As΂ȊOԂ
int ShellDeleteFileA ( HWND hWnd, const char *szFileName, int IsNoRecycleBin ) {

   if ( ! szFileName ) return 1 ;

   size_t nFileNameBufferSize = strlen ( szFileName ) + 1 ;
   if ( nFileNameBufferSize > MAX_PATH ) return 1 ;
   nFileNameBufferSize ++ ;      //  0 t邽

   char *szFileNameBuffer = (char*) malloc ( nFileNameBufferSize * sizeof(char) ) ;
   if ( ! szFileNameBuffer ) return 1 ;

   strcpy ( szFileNameBuffer, szFileName ) ;
   *( strend ( szFileNameBuffer ) + 1 ) = 0 ;

   int nResult = ShellDeleteMultipleFilesA ( hWnd, szFileNameBuffer, IsNoRecycleBin ) ;

   free ( szFileNameBuffer ) ;
   return nResult ;
}



// VF𗘗pĕ̃t@CRs[Eړ (ANSI)
// Ŏw肳镶ɂ́AɌ'\0'
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// szDstDir ɂ \ ŏItH_w
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As΂ȊOԂ
int ShellCopyMultipleFilesA ( HWND hWnd, const char *szFileNameBuffer, const char *szDstDir, int IsMove ) {

   if ( ! szFileNameBuffer ) return 1 ;
   if ( ! szDstDir ) return 1 ;

   SHFILEOPSTRUCTA ShFileOp = { 0 } ;
   ShFileOp.hwnd = hWnd ;
   ShFileOp.wFunc = IsMove ? FO_MOVE : FO_COPY ;
   ShFileOp.pFrom = szFileNameBuffer ;
   ShFileOp.pTo = szDstDir ;
   ShFileOp.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI | ( hWnd ? 0 : FOF_SILENT ) | FOF_NOCONFIRMMKDIR ;

   return SHFileOperationA ( & ShFileOp ) || ShFileOp.fAnyOperationsAborted ;
}



// VF𗘗pĂP̃t@CRs[Eړ (ANSI)
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// szDstDir ɂ \ ŏItH_w
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As΂ȊOԂ
int ShellCopyFileA ( HWND hWnd, const char *szFileName, const char *szDstDir, int IsMove ) {

   if ( ! szFileName ) return 1 ;

   size_t nFileNameBufferSize = strlen ( szFileName ) + 1 ;
   if ( nFileNameBufferSize > MAX_PATH ) return 1 ;
   nFileNameBufferSize ++ ;      //  0 t邽

   char *szFileNameBuffer = (char*) malloc ( nFileNameBufferSize * sizeof(char) ) ;
   if ( ! szFileNameBuffer ) return 1 ;

   strcpy ( szFileNameBuffer, szFileName ) ;
   *( strend ( szFileNameBuffer ) + 1 ) = 0 ;

   int nResult = ShellCopyMultipleFilesA ( hWnd, szFileNameBuffer, szDstDir, IsMove ) ;

   free ( szFileNameBuffer ) ;
   return nResult ;
}



/////////////////////////////
//       UNICODE         //
/////////////////////////////



// This function is not supported in Win95
#ifndef NTFUNC_IMPORT_IMPLICITLY
#define GETPROCADDRESS(dll,type,function) ( ! dll || ! function && ( function = (type) GetProcAddress ( dll, #function ) ) == NULL )
#define SHFileOperationW SHFileOperationW_
typedef int ( WINAPI *SHFILEOPERATIONW ) ( LPSHFILEOPSTRUCTW lpFileOp ) ;
static HINSTANCE hShell32 ;
static SHFILEOPERATIONW SHFileOperationW ;
static void __cdecl ExitProc ( void ) ;
#endif



// VF𗘗pĕ̃t@C폜 (UNICODE)
// 폜ꂽt@C͂ݔֈړ
// Ŏw肳镶ɂ́AɌ'\0'
// t@C̓tpXŎw
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As΂ȊOԂ
int ShellDeleteMultipleFilesW ( HWND hWnd, const wchar_t *szFileNameBuffer, int IsNoRecycleBin ) {

   if ( ! szFileNameBuffer ) return 1 ;

#ifndef NTFUNC_IMPORT_IMPLICITLY
   if ( ! hShell32 && ( hShell32 = LoadLibraryW ( L"SHELL32.DLL" ) ) ) atexit ( ExitProc ) ;
   if ( GETPROCADDRESS ( hShell32, SHFILEOPERATIONW, SHFileOperationW ) ) return 1 ;
#endif

   SHFILEOPSTRUCTW ShFileOp = { 0 } ;
   ShFileOp.hwnd = hWnd ;
   ShFileOp.wFunc = FO_DELETE ;
   ShFileOp.pFrom = szFileNameBuffer ;
   ShFileOp.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI | ( hWnd ? 0 : FOF_SILENT ) | ( IsNoRecycleBin ? 0 : FOF_ALLOWUNDO ) ;

   return SHFileOperationW ( & ShFileOp ) || ShFileOp.fAnyOperationsAborted ;
}



// VF𗘗pĂP̃t@C폜 (UNICODE)
// 폜ꂽt@C͂ݔֈړ
// t@C̓tpXŎw
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As΂ȊOԂ
int ShellDeleteFileW ( HWND hWnd, const wchar_t *szFileName, int IsNoRecycleBin ) {

   if ( ! szFileName ) return 1 ;

   size_t nFileNameBufferSize = wcslen ( szFileName ) + 1 ;
   if ( nFileNameBufferSize > MAX_LONG_PATH ) return 1 ;
   nFileNameBufferSize ++ ;      //  0 t邽

   wchar_t *szFileNameBuffer = (wchar_t*) malloc ( nFileNameBufferSize * sizeof(wchar_t) ) ;
   if ( ! szFileNameBuffer ) return 1 ;

   wcscpy ( szFileNameBuffer, szFileName ) ;
   *( wcsend ( szFileNameBuffer ) + 1 ) = 0 ;

   int nResult = ShellDeleteMultipleFilesW ( hWnd, szFileNameBuffer, IsNoRecycleBin ) ;

   free ( szFileNameBuffer ) ;
   return nResult ;
}



// VF𗘗pĕ̃t@CRs[Eړ (ANSI)
// Ŏw肳镶ɂ́AɌ'\0'
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// szDstDir ɂ \ ŏItH_w
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As΂ȊOԂ
int ShellCopyMultipleFilesW ( HWND hWnd, const wchar_t *szFileNameBuffer, const wchar_t *szDstDir, int IsMove ) {

   if ( ! szFileNameBuffer ) return 1 ;
   if ( ! szDstDir ) return 1 ;

#ifndef NTFUNC_IMPORT_IMPLICITLY
   if ( ! hShell32 && ( hShell32 = LoadLibraryW ( L"SHELL32.DLL" ) ) ) atexit ( ExitProc ) ;
   if ( GETPROCADDRESS ( hShell32, SHFILEOPERATIONW, SHFileOperationW ) ) return 1 ;
#endif

   SHFILEOPSTRUCTW ShFileOp = { 0 } ;
   ShFileOp.hwnd = hWnd ;
   ShFileOp.wFunc = IsMove ? FO_MOVE : FO_COPY ;
   ShFileOp.pFrom = szFileNameBuffer ;
   ShFileOp.pTo = szDstDir ;
   ShFileOp.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI | ( hWnd ? 0 : FOF_SILENT ) | FOF_NOCONFIRMMKDIR ;

   return SHFileOperationW ( & ShFileOp ) || ShFileOp.fAnyOperationsAborted ;
}



// VF𗘗pĂP̃t@CRs[Eړ (ANSI)
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// szDstDir ɂ \ ŏItH_w
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As΂ȊOԂ
int ShellCopyFileW ( HWND hWnd, const wchar_t *szFileName, const wchar_t *szDstDir, int IsMove ) {

   if ( ! szFileName ) return 1 ;

   size_t nFileNameBufferSize = wcslen ( szFileName ) + 1 ;
   if ( nFileNameBufferSize > MAX_LONG_PATH ) return 1 ;
   nFileNameBufferSize ++ ;      //  0 t邽

   wchar_t *szFileNameBuffer = (wchar_t*) malloc ( nFileNameBufferSize * sizeof(wchar_t) ) ;
   if ( ! szFileNameBuffer ) return 1 ;

   wcscpy ( szFileNameBuffer, szFileName ) ;
   *( wcsend ( szFileNameBuffer ) + 1 ) = 0 ;

   int nResult = ShellCopyMultipleFilesW ( hWnd, szFileNameBuffer, szDstDir, IsMove ) ;

   free ( szFileNameBuffer ) ;
   return nResult ;
}



#ifndef NTFUNC_IMPORT_IMPLICITLY
static void __cdecl ExitProc ( void ) {
   if ( hShell32 ) FreeLibrary ( hShell32 ) ;
}
#endif



